diff --git a/Documentation/libtraceevent-commands.txt b/Documentation/libtraceevent-commands.txt
index bec5520..add9185 100644
--- a/Documentation/libtraceevent-commands.txt
+++ b/Documentation/libtraceevent-commands.txt
@@ -150,4 +150,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-cpus.txt b/Documentation/libtraceevent-cpus.txt
index 5ad70e4..f3d04df 100644
--- a/Documentation/libtraceevent-cpus.txt
+++ b/Documentation/libtraceevent-cpus.txt
@@ -74,4 +74,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-endian_read.txt b/Documentation/libtraceevent-endian_read.txt
index e64851b..cf21e39 100644
--- a/Documentation/libtraceevent-endian_read.txt
+++ b/Documentation/libtraceevent-endian_read.txt
@@ -75,4 +75,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-event_find.txt b/Documentation/libtraceevent-event_find.txt
index 7bc062c..185880e 100644
--- a/Documentation/libtraceevent-event_find.txt
+++ b/Documentation/libtraceevent-event_find.txt
@@ -100,4 +100,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-event_get.txt b/Documentation/libtraceevent-event_get.txt
index 6525092..b1f3d8e 100644
--- a/Documentation/libtraceevent-event_get.txt
+++ b/Documentation/libtraceevent-event_get.txt
@@ -96,4 +96,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-event_list.txt b/Documentation/libtraceevent-event_list.txt
index fba350e..736d993 100644
--- a/Documentation/libtraceevent-event_list.txt
+++ b/Documentation/libtraceevent-event_list.txt
@@ -119,4 +119,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-event_print.txt b/Documentation/libtraceevent-event_print.txt
index 2c6a618..c729a87 100644
--- a/Documentation/libtraceevent-event_print.txt
+++ b/Documentation/libtraceevent-event_print.txt
@@ -127,4 +127,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-field_find.txt b/Documentation/libtraceevent-field_find.txt
index 0896af5..fa3066b 100644
--- a/Documentation/libtraceevent-field_find.txt
+++ b/Documentation/libtraceevent-field_find.txt
@@ -115,4 +115,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-field_get_val.txt b/Documentation/libtraceevent-field_get_val.txt
index 6324f0d..29f6583 100644
--- a/Documentation/libtraceevent-field_get_val.txt
+++ b/Documentation/libtraceevent-field_get_val.txt
@@ -119,4 +119,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-field_print.txt b/Documentation/libtraceevent-field_print.txt
index 9a9df98..2c2cf6c 100644
--- a/Documentation/libtraceevent-field_print.txt
+++ b/Documentation/libtraceevent-field_print.txt
@@ -123,4 +123,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-field_read.txt b/Documentation/libtraceevent-field_read.txt
index 64e9e25..96de895 100644
--- a/Documentation/libtraceevent-field_read.txt
+++ b/Documentation/libtraceevent-field_read.txt
@@ -78,4 +78,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-fields.txt b/Documentation/libtraceevent-fields.txt
index 1ccb531..a081690 100644
--- a/Documentation/libtraceevent-fields.txt
+++ b/Documentation/libtraceevent-fields.txt
@@ -102,4 +102,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-file_endian.txt b/Documentation/libtraceevent-file_endian.txt
index f401ad3..197954c 100644
--- a/Documentation/libtraceevent-file_endian.txt
+++ b/Documentation/libtraceevent-file_endian.txt
@@ -88,4 +88,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-filter.txt b/Documentation/libtraceevent-filter.txt
index 4a9962d..052e745 100644
--- a/Documentation/libtraceevent-filter.txt
+++ b/Documentation/libtraceevent-filter.txt
@@ -206,4 +206,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-func_apis.txt b/Documentation/libtraceevent-func_apis.txt
index f6aca0d..89e307a 100644
--- a/Documentation/libtraceevent-func_apis.txt
+++ b/Documentation/libtraceevent-func_apis.txt
@@ -180,4 +180,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-func_find.txt b/Documentation/libtraceevent-func_find.txt
index 04840e2..b7e324b 100644
--- a/Documentation/libtraceevent-func_find.txt
+++ b/Documentation/libtraceevent-func_find.txt
@@ -85,4 +85,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-handle.txt b/Documentation/libtraceevent-handle.txt
index 45b2017..5696b62 100644
--- a/Documentation/libtraceevent-handle.txt
+++ b/Documentation/libtraceevent-handle.txt
@@ -98,4 +98,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-header_page.txt b/Documentation/libtraceevent-header_page.txt
index 615d117..f8f72e5 100644
--- a/Documentation/libtraceevent-header_page.txt
+++ b/Documentation/libtraceevent-header_page.txt
@@ -99,4 +99,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-host_endian.txt b/Documentation/libtraceevent-host_endian.txt
index d5d375e..7fdfaed 100644
--- a/Documentation/libtraceevent-host_endian.txt
+++ b/Documentation/libtraceevent-host_endian.txt
@@ -101,4 +101,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-long_size.txt b/Documentation/libtraceevent-long_size.txt
index 01d78ea..a651438 100644
--- a/Documentation/libtraceevent-long_size.txt
+++ b/Documentation/libtraceevent-long_size.txt
@@ -75,4 +75,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-page_size.txt b/Documentation/libtraceevent-page_size.txt
index 452c0cf..ff60921 100644
--- a/Documentation/libtraceevent-page_size.txt
+++ b/Documentation/libtraceevent-page_size.txt
@@ -79,4 +79,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-parse_event.txt b/Documentation/libtraceevent-parse_event.txt
index f248114..dfbdeda 100644
--- a/Documentation/libtraceevent-parse_event.txt
+++ b/Documentation/libtraceevent-parse_event.txt
@@ -87,4 +87,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-parse_head.txt b/Documentation/libtraceevent-parse_head.txt
index c90f16c..c20a41d 100644
--- a/Documentation/libtraceevent-parse_head.txt
+++ b/Documentation/libtraceevent-parse_head.txt
@@ -79,4 +79,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-plugins.txt b/Documentation/libtraceevent-plugins.txt
index 4d63943..f06dc9c 100644
--- a/Documentation/libtraceevent-plugins.txt
+++ b/Documentation/libtraceevent-plugins.txt
@@ -119,4 +119,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-record_parse.txt b/Documentation/libtraceevent-record_parse.txt
index e9a6911..73a9654 100644
--- a/Documentation/libtraceevent-record_parse.txt
+++ b/Documentation/libtraceevent-record_parse.txt
@@ -134,4 +134,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-reg_event_handler.txt b/Documentation/libtraceevent-reg_event_handler.txt
index 53d37d7..1e5ec0e 100644
--- a/Documentation/libtraceevent-reg_event_handler.txt
+++ b/Documentation/libtraceevent-reg_event_handler.txt
@@ -153,4 +153,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-reg_print_func.txt b/Documentation/libtraceevent-reg_print_func.txt
index 708dce9..c3b3849 100644
--- a/Documentation/libtraceevent-reg_print_func.txt
+++ b/Documentation/libtraceevent-reg_print_func.txt
@@ -152,4 +152,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-set_flag.txt b/Documentation/libtraceevent-set_flag.txt
index b059978..b75426b 100644
--- a/Documentation/libtraceevent-set_flag.txt
+++ b/Documentation/libtraceevent-set_flag.txt
@@ -101,4 +101,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-strerror.txt b/Documentation/libtraceevent-strerror.txt
index ee4062a..f1cef05 100644
--- a/Documentation/libtraceevent-strerror.txt
+++ b/Documentation/libtraceevent-strerror.txt
@@ -82,4 +82,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent-tseq.txt b/Documentation/libtraceevent-tseq.txt
index 8ac6aa1..066f5e0 100644
--- a/Documentation/libtraceevent-tseq.txt
+++ b/Documentation/libtraceevent-tseq.txt
@@ -155,4 +155,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/
diff --git a/Documentation/libtraceevent.txt b/Documentation/libtraceevent.txt
index d530a7c..3365455 100644
--- a/Documentation/libtraceevent.txt
+++ b/Documentation/libtraceevent.txt
@@ -189,4 +189,4 @@ libtraceevent is Free Software licensed under the GNU LGPL 2.1
 
 RESOURCES
 ---------
-https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git
+https://git.kernel.org/pub/scm/libs/libtrace/libtraceevent.git/